## libime 1.1.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)
project(libime VERSION 1.1.5)
set(LibIME_VERSION ${PROJECT_VERSION})

find_package(ECM 1.0 REQUIRED)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

#########################################
# Options
#########################################
option(ENABLE_TEST "Build Test" On)
option(ENABLE_COVERAGE "Build the project with gcov support (Need ENABLE_TEST=On)" Off)
set(GCOV_TOOL "gcov" CACHE STRING "Path to gcov tool used by coverage.")
option(ENABLE_DOC "Build doxygen" Off)
option(ENABLE_DATA "Build data" On)

#########################################
# Dependency
#########################################

include(GNUInstallDirs)
include(FeatureSummary)
include(GenerateExportHeader)
include(CMakePackageConfigHelpers)
include(ECMSetupVersion)
include(ECMGenerateHeaders)
include(ECMGeneratePkgConfigFile)
include(ECMUninstallTarget)
include(CheckLibraryExists)
find_package(PkgConfig REQUIRED)

pkg_check_modules(ZSTD REQUIRED IMPORTED_TARGET "libzstd")

find_package(Fcitx5Utils REQUIRED)
include("${FCITX_INSTALL_CMAKECONFIG_DIR}/Fcitx5Utils/Fcitx5CompilerSettings.cmake")

find_package(Boost 1.61 REQUIRED COMPONENTS iostreams filesystem)
set(LIBIME_INSTALL_PKGDATADIR "${CMAKE_INSTALL_FULL_DATADIR}/libime")
set(LIBIME_INSTALL_LIBDATADIR "${CMAKE_INSTALL_FULL_LIBDIR}/libime")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

if(ENABLE_TEST)
    enable_testing()
    add_subdirectory(test)

    if (ENABLE_COVERAGE)
        add_custom_target(coverage
                        COMMAND "${CMAKE_CTEST_COMMAND}"
                        COMMAND lcov --gcov-tool "${GCOV_TOOL}" --no-external --capture --directory ./ -b "${CMAKE_CURRENT_SOURCE_DIR}" --output-file coverage.info
                        COMMAND lcov --remove coverage.info "*/kenlm/*" -o coverage.info
                        COMMAND genhtml coverage.info --output-directory "coverage_pages"
                        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
    endif()
endif()

add_subdirectory(src)
add_subdirectory(tools)

if (ENABLE_DATA)
  add_subdirectory(data)
endif()

if (ENABLE_DOC)
  find_package(Doxygen REQUIRED)
  file(READ "${CMAKE_CURRENT_SOURCE_DIR}/.codedocs" FCITX_DOXYGEN_CONFIGURATION)
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
    ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    @ONLY)
  add_custom_target(doc
      COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
      COMMENT "Generating API documentation with Doxygen"
      VERBATIM)
endif()

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== data/CMakeLists.txt ===
set(LM_TAR "lm_sc.arpa-20230712.tar.xz")
# Use our own file server for convenience.
set(LM_URL "https://download.fcitx-im.org/data/${LM_TAR}")

fcitx5_download(lm-download ${LM_URL} ${LM_TAR}
                badd62c16c6373787a0fda8f09cd452d12f60d5868856f651ceecf1a07baba32)
fcitx5_extract(lm-extract ${LM_TAR} DEPENDS lm-download
               OUTPUT lm_sc.arpa)

set(LM_SRC "${CMAKE_CURRENT_BINARY_DIR}/lm_sc.arpa")
set(LM_OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/sc.lm")
set(LM_PREDICT_OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/sc.lm.predict")
add_custom_command(
  OUTPUT "${LM_OUTPUT}"
  DEPENDS "${LM_SRC}" LibIME::slm_build_binary
  COMMAND LibIME::slm_build_binary -s -a 22 -q 8 trie "${LM_SRC}" "${LM_OUTPUT}")
add_custom_target(lm ALL DEPENDS "${LM_OUTPUT}")

add_custom_command(
  OUTPUT "${LM_PREDICT_OUTPUT}"
  DEPENDS "${LM_SRC}" lm LibIME::prediction
  COMMAND LibIME::prediction "${LM_OUTPUT}" "${LM_SRC}" "${LM_PREDICT_OUTPUT}")
add_custom_target(lm-predict ALL DEPENDS "${LM_PREDICT_OUTPUT}")

install(FILES "${LM_OUTPUT}" RENAME zh_CN.lm DESTINATION "${LIBIME_INSTALL_LIBDATADIR}")
install(FILES "${LM_PREDICT_OUTPUT}" RENAME zh_CN.lm.predict DESTINATION "${LIBIME_INSTALL_LIBDATADIR}")

set(DICT_TAR "dict-20230412.tar.xz")
set(DICT_URL "https://download.fcitx-im.org/data/${DICT_TAR}")

fcitx5_download(dict-download ${DICT_URL} ${DICT_TAR}
               f05fccaff9687900aac3d9ad5a81b20888b573201403fbcd9bbc7907d9e97507)
fcitx5_extract(dict-extract ${DICT_TAR} DEPENDS dict-download
               OUTPUT dict_sc.txt dict_extb.txt)

set(DICT_SRC "${CMAKE_CURRENT_BINARY_DIR}/dict_sc.txt")
set(DICT_OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/sc.dict")
add_custom_command(
  OUTPUT "${DICT_OUTPUT}"
  DEPENDS "${DICT_SRC}" LibIME::pinyindict
  COMMAND LibIME::pinyindict "${DICT_SRC}" "${DICT_OUTPUT}")

set(DICT_EXTB_SRC "${CMAKE_CURRENT_BINARY_DIR}/dict_extb.txt")
set(DICT_EXTB_OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/extb.dict")
add_custom_command(
  OUTPUT "${DICT_EXTB_OUTPUT}"
  DEPENDS "${DICT_EXTB_SRC}" LibIME::pinyindict
  COMMAND LibIME::pinyindict "${DICT_EXTB_SRC}" "${DICT_EXTB_OUTPUT}")
add_custom_target(dict ALL DEPENDS "${DICT_OUTPUT}" "${DICT_EXTB_OUTPUT}")
install(FILES "${DICT_OUTPUT}" "${DICT_EXTB_OUTPUT}" DESTINATION "${LIBIME_INSTALL_PKGDATADIR}")

set(TABLE_DICT_URL "https://download.fcitx-im.org/data/table-20240108.tar.gz")
set(TABLE_DICT_TAR "table-20240108.tar.gz")
set(TABLE_TXT_FILES db.txt erbi.txt qxm.txt wanfeng.txt
                      wbpy.txt wbx.txt zrm.txt cj.txt)
fcitx5_download(table-dict-download ${TABLE_DICT_URL} ${TABLE_DICT_TAR}
                729c596d86907de727c74d0fc3fd241c406c5debd2b4cb74eefe022387ee9dae)
fcitx5_extract(table-dict-extract ${TABLE_DICT_TAR} DEPENDS table-dict-download
               OUTPUT ${TABLE_TXT_FILES})

set(TABLE_DICT_FILES)
foreach(TABLE_TXT_FILE ${TABLE_TXT_FILES})
  string(REPLACE .txt .main.dict TABLE_DICT_FILE ${TABLE_TXT_FILE})
  add_custom_command(OUTPUT ${TABLE_DICT_FILE}
                     DEPENDS ${TABLE_TXT_FILE} LibIME::tabledict
                     COMMAND LibIME::tabledict ${TABLE_TXT_FILE} ${CMAKE_CURRENT_BINARY_DIR}/${TABLE_DICT_FILE})
  list(APPEND TABLE_DICT_FILES ${CMAKE_CURRENT_BINARY_DIR}/${TABLE_DICT_FILE})
endforeach()

add_custom_target(table-dict ALL DEPENDS ${TABLE_DICT_FILES})
install(FILES ${TABLE_DICT_FILES} DESTINATION "${LIBIME_INSTALL_PKGDATADIR}")

=== tools/CMakeLists.txt ===
add_executable(libime_slm_build_binary ../src/libime/core/kenlm/lm/build_binary_main.cc)
target_link_libraries(libime_slm_build_binary kenlm)

install(TARGETS libime_slm_build_binary DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT tools)
add_executable(LibIME::slm_build_binary ALIAS libime_slm_build_binary)

add_executable(libime_prediction libime_prediction.cpp)
target_link_libraries(libime_prediction LibIME::Core)
install(TARGETS libime_prediction DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT tools)
add_executable(LibIME::prediction ALIAS libime_prediction)

add_executable(libime_pinyindict libime_pinyindict.cpp)
target_link_libraries(libime_pinyindict LibIME::Pinyin)
install(TARGETS libime_pinyindict DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT tools)
add_executable(LibIME::pinyindict ALIAS libime_pinyindict)

add_executable(libime_history libime_history.cpp)
target_link_libraries(libime_history LibIME::Core)
install(TARGETS libime_history DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT tools)
add_executable(LibIME::history ALIAS libime_history)

add_executable(libime_tabledict libime_tabledict.cpp)
target_link_libraries(libime_tabledict LibIME::Table)
install(TARGETS libime_tabledict DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT tools)
add_executable(LibIME::tabledict ALIAS libime_tabledict)

add_executable(libime_migrate_fcitx4_table libime_migrate_fcitx4_table.cpp)
target_link_libraries(libime_migrate_fcitx4_table LibIME::Table Boost::iostreams Boost::filesystem)
install(TARGETS libime_migrate_fcitx4_table DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT tools)
add_executable(LibIME::migrate_fcitx4_table ALIAS libime_migrate_fcitx4_table)

add_executable(libime_migrate_fcitx4_pinyin libime_migrate_fcitx4_pinyin.cpp)
target_link_libraries(libime_migrate_fcitx4_pinyin LibIME::Pinyin Boost::iostreams Boost::filesystem)
install(TARGETS libime_migrate_fcitx4_pinyin DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT tools)
add_executable(LibIME::migrate_fcitx4_pinyin ALIAS libime_migrate_fcitx4_pinyin)

=== src/libime/core/CMakeLists.txt ===
# logic from setup.py
file(GLOB __KENLM_SRCS kenlm/lm/*.cc kenlm/util/*.cc kenlm/util/double-conversion/*.cc)
set(KENLM_SRCS)
foreach(f ${__KENLM_SRCS})
    string(REGEX MATCH "test\\.cc" IS_TEST ${f})
    string(REGEX MATCH "main\\.cc" IS_MAIN ${f})
    if(NOT IS_TEST AND NOT IS_MAIN)
        set(KENLM_SRCS ${KENLM_SRCS} ${f})
    endif()
endforeach()

add_library(kenlm STATIC ${KENLM_SRCS})
target_include_directories(kenlm PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/kenlm>)
target_compile_definitions(kenlm PUBLIC -DKENLM_MAX_ORDER=3 PRIVATE -DNDEBUG)
target_link_libraries(kenlm PUBLIC Boost::boost PkgConfig::ZSTD)
set_target_properties(kenlm PROPERTIES
  CXX_STANDARD 11
  POSITION_INDEPENDENT_CODE ON)

if(UNIX)
  check_library_exists(rt clock_gettime "clock_gettime from librt" HAVE_CLOCKGETTIME_RT)
  if (HAVE_CLOCKGETTIME_RT)
    target_link_libraries(kenlm PUBLIC rt)
  else()
    check_library_exists(c clock_gettime "clock_gettime from the libc" HAVE_CLOCKGETTIME)
  endif()

  if (HAVE_CLOCKGETTIME_RT OR HAVE_CLOCKGETTIME)
    target_compile_definitions(kenlm PRIVATE -DHAVE_CLOCKGETTIME)
  endif()
endif()

set(LIBIME_HDRS
    datrie.h
    decoder.h
    languagemodel.h
    inputbuffer.h
    segmentgraph.h
    lattice.h
    languagemodel.h
    historybigram.h
    dictionary.h
    userlanguagemodel.h
    lrucache.h
    prediction.h
    triedictionary.h
    utils.h
    ${CMAKE_CURRENT_BINARY_DIR}/libimecore_export.h
    )

set(LIBIME_SRCS
    datrie.cpp
    decoder.cpp
    languagemodel.cpp
    inputbuffer.cpp
    lattice.cpp
    userlanguagemodel.cpp
    historybigram.cpp
    segmentgraph.cpp
    utils.cpp
    prediction.cpp
    triedictionary.cpp
    )

ecm_setup_version(PROJECT
                  VARIABLE_PREFIX IMECore
                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/LibIMECoreConfigVersion.cmake")
# the cmake if will
set(IMECore_SOVERSION 0)

add_library(IMECore SHARED ${LIBIME_SRCS})
set_target_properties(IMECore
                      PROPERTIES VERSION ${IMECore_VERSION}
                      SOVERSION ${IMECore_SOVERSION}
                      EXPORT_NAME Core
)
target_include_directories(IMECore PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../..>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_FULL_INCLUDEDIR}/LibIME>)

target_link_libraries(IMECore PUBLIC Fcitx5::Utils Boost::boost PRIVATE kenlm Boost::iostreams PkgConfig::ZSTD)

install(TARGETS IMECore EXPORT LibIMECoreTargets LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}" COMPONENT lib)
install(FILES ${LIBIME_HDRS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/LibIME/libime/core" COMPONENT header)

add_library(LibIME::Core ALIAS IMECore)

configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/LibIMECoreConfig.cmake.in"
                              "${CMAKE_CURRENT_BINARY_DIR}/LibIMECoreConfig.cmake"
                              INSTALL_DESTINATION  "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMECore"
)

generate_export_header(IMECore BASE_NAME LibIMECore)

install(EXPORT LibIMECoreTargets
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMECore"
        FILE LibIMECoreTargets.cmake
        NAMESPACE LibIME::
        COMPONENT Devel)

install(FILES  "${CMAKE_CURRENT_BINARY_DIR}/LibIMECoreConfig.cmake"
               "${CMAKE_CURRENT_BINARY_DIR}/LibIMECoreConfigVersion.cmake"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMECore"
        COMPONENT Devel)

=== src/libime/pinyin/CMakeLists.txt ===
set(LIBIME_PINYIN_HDRS
    pinyincontext.h
    pinyindata.h
    pinyindecoder.h
    pinyindictionary.h
    pinyinencoder.h
    pinyinime.h
    pinyinmatchstate.h
    pinyinmatchstate_p.h
    pinyinprediction.h
    shuangpindata.h
    shuangpinprofile.h
    ${CMAKE_CURRENT_BINARY_DIR}/libimepinyin_export.h
    )

set(LIBIME_PINYIN_SRCS
    pinyincontext.cpp
    pinyindata.cpp
    pinyindecoder.cpp
    pinyindictionary.cpp
    pinyinencoder.cpp
    pinyinime.cpp
    pinyinmatchstate.cpp
    shuangpinprofile.cpp
    pinyinprediction.cpp
    )

ecm_setup_version(PROJECT
                  VARIABLE_PREFIX IMEPinyin
                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/LibIMEPinyinConfigVersion.cmake")
set(IMEPinyin_SOVERSION 0)

add_library(IMEPinyin SHARED ${LIBIME_PINYIN_SRCS})
set_target_properties(IMEPinyin PROPERTIES
                      VERSION ${IMEPinyin_VERSION}
                      SOVERSION ${IMEPinyin_SOVERSION}
                      EXPORT_NAME Pinyin
)
target_include_directories(IMEPinyin PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../..>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_FULL_INCLUDEDIR}/LibIME>)

target_link_libraries(IMEPinyin PUBLIC Fcitx5::Utils Boost::boost LibIME::Core PRIVATE Boost::iostreams PkgConfig::ZSTD)

install(TARGETS IMEPinyin EXPORT LibIMEPinyinTargets LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}" COMPONENT lib)
install(FILES ${LIBIME_PINYIN_HDRS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/LibIME/libime/pinyin" COMPONENT header)

add_library(LibIME::Pinyin ALIAS IMEPinyin)

configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/LibIMEPinyinConfig.cmake.in"
                              "${CMAKE_CURRENT_BINARY_DIR}/LibIMEPinyinConfig.cmake"
                              INSTALL_DESTINATION  "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMEPinyin"
)

generate_export_header(IMEPinyin BASE_NAME LibIMEPinyin)

install(EXPORT LibIMEPinyinTargets
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMEPinyin"
        FILE LibIMEPinyinTargets.cmake
        NAMESPACE LibIME::
        COMPONENT Devel)

install(FILES  "${CMAKE_CURRENT_BINARY_DIR}/LibIMEPinyinConfig.cmake"
               "${CMAKE_CURRENT_BINARY_DIR}/LibIMEPinyinConfigVersion.cmake"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMEPinyin"
        COMPONENT Devel)

=== src/libime/table/CMakeLists.txt ===
set(LIBIME_TABLE_HDRS
    tablebaseddictionary.h
    tablecontext.h
    tableoptions.h
    tablerule.h
    tabledecoder.h
    autophrasedict.h
    ${CMAKE_CURRENT_BINARY_DIR}/libimetable_export.h
    )

set(LIBIME_TABLE_SRCS
    tablebaseddictionary.cpp
    tablecontext.cpp
    tableoptions.cpp
    tabledecoder.cpp
    autophrasedict.cpp
    log.cpp
    tablerule.cpp
    )

ecm_setup_version(PROJECT
                  VARIABLE_PREFIX IMETable
                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/LibIMETableConfigVersion.cmake")
set(IMETable_SOVERSION 0)

add_library(IMETable SHARED ${LIBIME_TABLE_SRCS})
set_target_properties(IMETable
                      PROPERTIES VERSION ${IMETable_VERSION}
                      SOVERSION ${IMETable_SOVERSION}
                      EXPORT_NAME Table
)

target_include_directories(IMETable PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../..>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_FULL_INCLUDEDIR}/LibIME>)

target_link_libraries(IMETable PUBLIC Fcitx5::Utils Boost::boost LibIME::Core PRIVATE Boost::iostreams PkgConfig::ZSTD)

install(TARGETS IMETable EXPORT LibIMETableTargets LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}" COMPONENT lib)
install(FILES ${LIBIME_TABLE_HDRS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/LibIME/libime/table" COMPONENT header)

add_library(LibIME::Table ALIAS IMETable)

configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/LibIMETableConfig.cmake.in"
                              "${CMAKE_CURRENT_BINARY_DIR}/LibIMETableConfig.cmake"
                              INSTALL_DESTINATION  "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMETable"
)

generate_export_header(IMETable BASE_NAME LibIMETable)

install(EXPORT LibIMETableTargets
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMETable"
        FILE LibIMETableTargets.cmake
        NAMESPACE LibIME::
        COMPONENT Devel)

install(FILES  "${CMAKE_CURRENT_BINARY_DIR}/LibIMETableConfig.cmake"
               "${CMAKE_CURRENT_BINARY_DIR}/LibIMETableConfigVersion.cmake"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMETable"
        COMPONENT Devel)

=== src/libime/core/kenlm/lm/CMakeLists.txt ===
# Explicitly list the source files for this subdirectory
#
# If you add any source files to this subdirectory
#    that should be included in the kenlm library,
#        (this excludes any unit test files)
#    you should add them to the following list:
set(KENLM_LM_SOURCE
	bhiksha.cc
	binary_format.cc
	config.cc
	lm_exception.cc
	model.cc
	quantize.cc
	read_arpa.cc
	search_hashed.cc
	search_trie.cc
	sizes.cc
	trie.cc
	trie_sort.cc
	value_build.cc
	virtual_interface.cc
	vocab.cc
)


# Group these objects together for later use.
#
# Given add_library(foo OBJECT ${my_foo_sources}),
# refer to these objects as $<TARGET_OBJECTS:foo>
#
add_subdirectory(common)

add_library(kenlm ${KENLM_LM_SOURCE} ${KENLM_LM_COMMON_SOURCE})
set_target_properties(kenlm PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_link_libraries(kenlm PUBLIC kenlm_util Threads::Threads)
# Since headers are relative to `include/kenlm` at install time, not just `include`
target_include_directories(kenlm PUBLIC $<INSTALL_INTERFACE:include/kenlm>)

set(KENLM_MAX_ORDER 6 CACHE STRING "Maximum supported ngram order")
target_compile_definitions(kenlm PUBLIC -DKENLM_MAX_ORDER=${KENLM_MAX_ORDER})

# This directory has children that need to be processed
add_subdirectory(builder)
add_subdirectory(filter)
add_subdirectory(interpolate)

# Explicitly list the executable files to be compiled
set(EXE_LIST
  query
  fragment
  build_binary
  kenlm_benchmark
)

set(LM_LIBS kenlm kenlm_util Threads::Threads)

install(
  TARGETS kenlm
  EXPORT kenlmTargets
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
  INCLUDES DESTINATION include
)

AddExes(EXES ${EXE_LIST}
        LIBRARIES ${LM_LIBS})

if(BUILD_TESTING)

  set(KENLM_BOOST_TESTS_LIST left_test partial_test)
  AddTests(TESTS ${KENLM_BOOST_TESTS_LIST}
           LIBRARIES ${LM_LIBS}
           TEST_ARGS ${CMAKE_CURRENT_SOURCE_DIR}/test.arpa)

  # model_test requires an extra command line parameter
  KenLMAddTest(TEST model_test
               LIBRARIES ${LM_LIBS}
               TEST_ARGS ${CMAKE_CURRENT_SOURCE_DIR}/test.arpa
                         ${CMAKE_CURRENT_SOURCE_DIR}/test_nounk.arpa)
endif()

=== src/libime/core/kenlm/util/double-conversion/CMakeLists.txt ===
# This CMake file was created by Lane Schwartz <dowobeha@gmail.com>

# Explicitly list the source files for this subdirectory
#
# If you add any source files to this subdirectory
#    that should be included in the kenlm library,
#        (this excludes any unit test files)
#    you should add them to the following list:
#
# In order to allow CMake files in the parent directory
#    to see this variable definition, we set PARENT_SCOPE.
#
# In order to set correct paths to these files
#    when this variable is referenced by CMake files in the parent directory,
#    we prefix all files with ${CMAKE_CURRENT_SOURCE_DIR}.
#
set(KENLM_UTIL_DOUBLECONVERSION_SOURCE
		${CMAKE_CURRENT_SOURCE_DIR}/bignum-dtoa.cc
		${CMAKE_CURRENT_SOURCE_DIR}/bignum.cc
		${CMAKE_CURRENT_SOURCE_DIR}/cached-powers.cc
		${CMAKE_CURRENT_SOURCE_DIR}/fast-dtoa.cc
		${CMAKE_CURRENT_SOURCE_DIR}/fixed-dtoa.cc
		${CMAKE_CURRENT_SOURCE_DIR}/strtod.cc
		${CMAKE_CURRENT_SOURCE_DIR}/double-to-string.cc
		${CMAKE_CURRENT_SOURCE_DIR}/string-to-double.cc
	PARENT_SCOPE)

=== debian/changelog ===
libime (1.1.5-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Tue, 16 Jan 2024 23:30:20 -0500

libime (1.1.4-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Sat, 06 Jan 2024 10:02:08 -0500

libime (1.1.3-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Fri, 03 Nov 2023 15:18:55 -0400

## libime 1.1.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.7)
-project(libime VERSION 1.1.5)
+project(libime VERSION 1.1.8)
 set(LibIME_VERSION ${PROJECT_VERSION})
 
 find_package(ECM 1.0 REQUIRED)

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -25,11 +25,11 @@
 install(FILES "${LM_OUTPUT}" RENAME zh_CN.lm DESTINATION "${LIBIME_INSTALL_LIBDATADIR}")
 install(FILES "${LM_PREDICT_OUTPUT}" RENAME zh_CN.lm.predict DESTINATION "${LIBIME_INSTALL_LIBDATADIR}")
 
-set(DICT_TAR "dict-20230412.tar.xz")
+set(DICT_TAR "dict-20240416.tar.zst")
 set(DICT_URL "https://download.fcitx-im.org/data/${DICT_TAR}")
 
 fcitx5_download(dict-download ${DICT_URL} ${DICT_TAR}
-               f05fccaff9687900aac3d9ad5a81b20888b573201403fbcd9bbc7907d9e97507)
+               9c262cbfa306cb4c3b055991b7e22b453e0f267f20ceb5d9d9e5f8fbe4f2d367)
 fcitx5_extract(dict-extract ${DICT_TAR} DEPENDS dict-download
                OUTPUT dict_sc.txt dict_extb.txt)

=== src/libime/pinyin/CMakeLists.txt ===
--- 
+++ 
@@ -10,6 +10,7 @@
     pinyinprediction.h
     shuangpindata.h
     shuangpinprofile.h
+    pinyincorrectionprofile.h
     ${CMAKE_CURRENT_BINARY_DIR}/libimepinyin_export.h
     )
 
@@ -23,6 +24,7 @@
     pinyinmatchstate.cpp
     shuangpinprofile.cpp
     pinyinprediction.cpp
+    pinyincorrectionprofile.cpp
     )
 
 ecm_setup_version(PROJECT

=== debian/changelog ===
libime (1.1.8-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Boyuan Yang <byang@debian.org>  Fri, 05 Jul 2024 15:59:24 -0400

libime (1.1.8-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Sat, 01 Jun 2024 08:06:56 -0400

libime (1.1.7-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Boyuan Yang <byang@debian.org>  Mon, 29 Apr 2024 16:20:05 -0400

libime (1.1.7-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Wed, 24 Apr 2024 20:31:59 -0400

libime (1.1.6-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Mon, 18 Mar 2024 22:16:26 -0400

## libime 1.1.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.7)
-project(libime VERSION 1.1.8)
+project(libime VERSION 1.1.9)
 set(LibIME_VERSION ${PROJECT_VERSION})
 
 find_package(ECM 1.0 REQUIRED)

=== debian/changelog ===
libime (1.1.9-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Tue, 08 Oct 2024 19:03:02 -0400

## libime 1.1.10

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,9 @@
-set(LM_TAR "lm_sc.arpa-20230712.tar.xz")
+set(LM_TAR "lm_sc.arpa-20250113.tar.zst")
 # Use our own file server for convenience.
 set(LM_URL "https://download.fcitx-im.org/data/${LM_TAR}")
 
 fcitx5_download(lm-download ${LM_URL} ${LM_TAR}
-                badd62c16c6373787a0fda8f09cd452d12f60d5868856f651ceecf1a07baba32)
+                ee83ecf20d52e8bccdba4cf6cd57183d53c257713a5eb77ee3a63d50fc3796dd)
 fcitx5_extract(lm-extract ${LM_TAR} DEPENDS lm-download
                OUTPUT lm_sc.arpa)
 
@@ -25,11 +25,11 @@
 install(FILES "${LM_OUTPUT}" RENAME zh_CN.lm DESTINATION "${LIBIME_INSTALL_LIBDATADIR}")
 install(FILES "${LM_PREDICT_OUTPUT}" RENAME zh_CN.lm.predict DESTINATION "${LIBIME_INSTALL_LIBDATADIR}")
 
-set(DICT_TAR "dict-20240416.tar.zst")
+set(DICT_TAR "dict-20241001.tar.zst")
 set(DICT_URL "https://download.fcitx-im.org/data/${DICT_TAR}")
 
 fcitx5_download(dict-download ${DICT_URL} ${DICT_TAR}
-               9c262cbfa306cb4c3b055991b7e22b453e0f267f20ceb5d9d9e5f8fbe4f2d367)
+               d3313b88a68620a23bc8d5f9564cf1b678848dc7af541c4f5f02198e5a3686bf)
 fcitx5_extract(dict-extract ${DICT_TAR} DEPENDS dict-download
                OUTPUT dict_sc.txt dict_extb.txt)
 
@@ -49,12 +49,12 @@
 add_custom_target(dict ALL DEPENDS "${DICT_OUTPUT}" "${DICT_EXTB_OUTPUT}")
 install(FILES "${DICT_OUTPUT}" "${DICT_EXTB_OUTPUT}" DESTINATION "${LIBIME_INSTALL_PKGDATADIR}")
 
-set(TABLE_DICT_URL "https://download.fcitx-im.org/data/table-20240108.tar.gz")
-set(TABLE_DICT_TAR "table-20240108.tar.gz")
+set(TABLE_DICT_TAR "table-20240108.tar.zst")
+set(TABLE_DICT_URL "https://download.fcitx-im.org/data/${TABLE_DICT_TAR}")
 set(TABLE_TXT_FILES db.txt erbi.txt qxm.txt wanfeng.txt
                       wbpy.txt wbx.txt zrm.txt cj.txt)
 fcitx5_download(table-dict-download ${TABLE_DICT_URL} ${TABLE_DICT_TAR}
-                729c596d86907de727c74d0fc3fd241c406c5debd2b4cb74eefe022387ee9dae)
+                3e9d87b04a393f131723472c8eaa860dd23c378a3d4f6a9005513b2a95b3614b)
 fcitx5_extract(table-dict-extract ${TABLE_DICT_TAR} DEPENDS table-dict-download
                OUTPUT ${TABLE_TXT_FILES})

=== src/libime/core/CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
     endif()
 endforeach()
 
-add_library(kenlm STATIC ${KENLM_SRCS})
+add_library(kenlm OBJECT ${KENLM_SRCS})
 target_include_directories(kenlm PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/kenlm>)
 target_compile_definitions(kenlm PUBLIC -DKENLM_MAX_ORDER=3 PRIVATE -DNDEBUG)
 target_link_libraries(kenlm PUBLIC Boost::boost PkgConfig::ZSTD)
@@ -50,6 +50,7 @@
 
 set(LIBIME_SRCS
     datrie.cpp
+    dictionary.cpp
     decoder.cpp
     languagemodel.cpp
     inputbuffer.cpp
@@ -68,7 +69,7 @@
 # the cmake if will
 set(IMECore_SOVERSION 0)
 
-add_library(IMECore SHARED ${LIBIME_SRCS})
+add_library(IMECore ${LIBIME_SRCS})
 set_target_properties(IMECore
                       PROPERTIES VERSION ${IMECore_VERSION}
                       SOVERSION ${IMECore_SOVERSION}

=== src/libime/table/CMakeLists.txt ===
--- 
+++ 
@@ -23,7 +23,7 @@
                   PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/LibIMETableConfigVersion.cmake")
 set(IMETable_SOVERSION 0)
 
-add_library(IMETable SHARED ${LIBIME_TABLE_SRCS})
+add_library(IMETable ${LIBIME_TABLE_SRCS})
 set_target_properties(IMETable
                       PROPERTIES VERSION ${IMETable_VERSION}
                       SOVERSION ${IMETable_SOVERSION}

=== debian/changelog ===
libime (1.1.10-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Thu, 23 Jan 2025 12:54:18 -0500

=== debian/control ===
Source: libime
Section: libs
Priority: optional
Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
Build-Depends:
 cmake (>= 3.7),
 debhelper-compat (= 13),
 extra-cmake-modules,
 libboost-dev (>= 1.61),
 libboost-filesystem-dev (>= 1.61),
 libboost-iostreams-dev (>= 1.61),
 libdouble-conversion-dev (>= 3.1.5-5~),
 libfcitx5utils-dev (>= 5.1~),
 libzstd-dev,
 pkg-config,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://github.com/fcitx/libime
Vcs-Git: https://salsa.debian.org/input-method-team/libime.git
Vcs-Browser: https://salsa.debian.org/input-method-team/libime

Package: libime-bin
Architecture: any
Multi-Arch: no
Section: utils
Depends:
 libimecore0 (= ${binary:Version}),
 libimepinyin0 (= ${binary:Version}),
 libimetable0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Generic Input Method Implementation (tools)
 Libime is a generic input method implementation library. It is mainly
 used by fcitx5, the next generation of fcitx input method framework.
 .
 This package provides tools provided by libime.

Package: libime-data
Architecture: all
Multi-Arch: foreign
Section: utils
Depends:
 libime-data-language-model (<< ${source:Version}.1~),
 libime-data-language-model (>= ${source:Version}),
 ${misc:Depends},
Description: Generic Input Method Implementation library (data files)
 Libime is a generic input method implementation library. It is mainly
 used by fcitx5, the next generation of fcitx input method framework.
 .
 This package provides architecture-independent data files.

Package: libime-data-language-model
Architecture: any
Multi-Arch: same
Section: utils
Depends:
 ${misc:Depends},
Breaks:
 libimecore0 (<< 1.0.1-2),
Replaces:
 libimecore0 (<< 1.0.1-2),
Description: Generic Input Method Implementation library (language model)
 Libime is a generic input method implementation library. It is mainly
 used by fcitx5, the next generation of fcitx input method framework.
 .
 This package provides architecture-dependent language models.

Package: libimecore-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libimecore0 (= ${binary:Version}),
 ${misc:Depends},
Description: Generic Input Method Implementation (core dev files)
 Libime is a generic input method implementation library. It is mainly
 used by fcitx5, the next generation of fcitx input method framework.
 .
 This package provides development files for core library.

Package: libimecore0
Architecture: any
Multi-Arch: same
Depends:
 libime-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Generic Input Method Implementation (core library)
 Libime is a generic input method implementation library. It is mainly
 used by fcitx5, the next generation of fcitx input method framework.
 .
 This package provides its core library.

Package: libimepinyin-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libimepinyin0 (= ${binary:Version}),
 ${misc:Depends},
Description: Generic Input Method Implementation (pinyin dev files)
 Libime is a generic input method implementation library. It is mainly
 used by fcitx5, the next generation of fcitx input method framework.
 .
 This package provides development files for pinyin library.

Package: libimepinyin0
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Generic Input Method Implementation (pinyin library)
 Libime is a generic input method implementation library. It is mainly
 used by fcitx5, the next generation of fcitx input method framework.
 .
 This package provides its pinyin library.

Package: libimetable-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libimetable0 (= ${binary:Version}),
 ${misc:Depends},
Description: Generic Input Method Implementation (table dev files)
 Libime is a generic input method implementation library. It is mainly
 used by fcitx5, the next generation of fcitx input method framework.
 .
 This package provides development files for table library.

Package: libimetable0
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Generic Input Method Implementation (table library)
 Libime is a generic input method implementation library. It is mainly
 used by fcitx5, the next generation of fcitx input method framework.
 .
 This package provides its table library.

## libime 1.1.10%2Bdict20250327

=== debian/changelog ===
libime (1.1.10+dict20250327-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Boyuan Yang <byang@debian.org>  Wed, 06 Aug 2025 13:35:00 -0400

libime (1.1.10+dict20250327-1) unstable; urgency=medium

  * New upstream snapshot with new extb dictionary.
  * debian/control: Move package description to the source package section.

 -- Boyuan Yang <byang@debian.org>  Thu, 24 Apr 2025 10:11:00 -0400

libime (1.1.10-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Boyuan Yang <byang@debian.org>  Sat, 08 Feb 2025 13:59:07 -0500

=== debian/control ===
Source: libime
Section: libs
Priority: optional
Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
Build-Depends:
 cmake (>= 3.7),
 debhelper-compat (= 13),
 extra-cmake-modules,
 libboost-dev (>= 1.61),
 libboost-filesystem-dev (>= 1.61),
 libboost-iostreams-dev (>= 1.61),
 libdouble-conversion-dev (>= 3.1.5-5~),
 libfcitx5utils-dev (>= 5.1~),
 libzstd-dev,
 pkgconf,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://github.com/fcitx/libime
Vcs-Git: https://salsa.debian.org/input-method-team/libime.git
Vcs-Browser: https://salsa.debian.org/input-method-team/libime
Description: Generic Input Method Implementation
 Libime is a generic input method implementation library. It is mainly
 used by fcitx5, the next generation of fcitx input method framework.

Package: libime-bin
Architecture: any
Multi-Arch: no
Section: utils
Depends:
 libimecore0 (= ${binary:Version}),
 libimepinyin0 (= ${binary:Version}),
 libimetable0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (tools)
 ${source:Extended-Description}
 .
 This package provides tools provided by libime.

Package: libime-data
Architecture: all
Multi-Arch: foreign
Section: utils
Depends:
 libime-data-language-model (<< ${source:Version}.1~),
 libime-data-language-model (>= ${source:Version}),
 ${misc:Depends},
Description: ${source:Synopsis} (data files)
 ${source:Extended-Description}
 .
 This package provides architecture-independent data files.

Package: libime-data-language-model
Architecture: any
Multi-Arch: same
Section: utils
Depends:
 ${misc:Depends},
Breaks:
 libimecore0 (<< 1.0.1-2),
Replaces:
 libimecore0 (<< 1.0.1-2),
Description: ${source:Synopsis} (language model)
 ${source:Extended-Description}
 .
 This package provides architecture-dependent language models.

Package: libimecore-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libimecore0 (= ${binary:Version}),
 ${misc:Depends},
Description: ${source:Synopsis} (core dev files)
 ${source:Extended-Description}
 .
 This package provides development files for core library.

Package: libimecore0
Architecture: any
Multi-Arch: same
Depends:
 libime-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (core library)
 ${source:Extended-Description}
 .
 This package provides its core library.

Package: libimepinyin-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libimepinyin0 (= ${binary:Version}),
 ${misc:Depends},
Description: ${source:Synopsis} (pinyin dev files)
 ${source:Extended-Description}
 .
 This package provides development files for pinyin library.

Package: libimepinyin0
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (pinyin library)
 ${source:Extended-Description}
 .
 This package provides its pinyin library.

Package: libimetable-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libimetable0 (= ${binary:Version}),
 ${misc:Depends},
Description: ${source:Synopsis} (table dev files)
 ${source:Extended-Description}
 .
 This package provides development files for table library.

Package: libimetable0
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (table library)
 ${source:Extended-Description}
 .
 This package provides its table library.

## libime 1.1.10+dict20250327

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
-cmake_minimum_required(VERSION 3.7)
-project(libime VERSION 1.1.9)
+cmake_minimum_required(VERSION 3.12)
+project(libime VERSION 1.1.10)
 set(LibIME_VERSION ${PROJECT_VERSION})
 
 find_package(ECM 1.0 REQUIRED)
@@ -8,11 +8,13 @@
 #########################################
 # Options
 #########################################
+option(BUILD_SHARED_LIBS "Build library as shared libs" On)
 option(ENABLE_TEST "Build Test" On)
 option(ENABLE_COVERAGE "Build the project with gcov support (Need ENABLE_TEST=On)" Off)
 set(GCOV_TOOL "gcov" CACHE STRING "Path to gcov tool used by coverage.")
 option(ENABLE_DOC "Build doxygen" Off)
 option(ENABLE_DATA "Build data" On)
+option(ENABLE_TOOLS "Build tools" On)
 
 #########################################
 # Dependency
@@ -34,7 +36,19 @@
 find_package(Fcitx5Utils REQUIRED)
 include("${FCITX_INSTALL_CMAKECONFIG_DIR}/Fcitx5Utils/Fcitx5CompilerSettings.cmake")
 
-find_package(Boost 1.61 REQUIRED COMPONENTS iostreams filesystem)
+include(CheckCXXSourceCompiles)
+check_cxx_source_compiles("
+#include <filesystem>
+int main() {
+    return std::filesystem::absolute(\".\").string()[0] == '/';
+}
+" HAS_STD_FILESYSTEM)
+
+find_package(Boost 1.61 REQUIRED COMPONENTS iostreams)
+if (NOT HAS_STD_FILESYSTEM)
+    find_package(Boost REQUIRED COMPONENTS filesystem)
+endif()
+
 set(LIBIME_INSTALL_PKGDATADIR "${CMAKE_INSTALL_FULL_DATADIR}/libime")
 set(LIBIME_INSTALL_LIBDATADIR "${CMAKE_INSTALL_FULL_LIBDIR}/libime")
 
@@ -56,7 +70,10 @@
 endif()
 
 add_subdirectory(src)
-add_subdirectory(tools)
+
+if (ENABLE_TOOLS)
+  add_subdirectory(tools)
+endif()
 
 if (ENABLE_DATA)
   add_subdirectory(data)

=== tools/CMakeLists.txt ===
--- 
+++ 
@@ -24,12 +24,19 @@
 install(TARGETS libime_tabledict DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT tools)
 add_executable(LibIME::tabledict ALIAS libime_tabledict)
 
+add_library(filesystem_helper STATIC filesystem_helper.cpp)
+if (HAS_STD_FILESYSTEM)
+    target_compile_definitions(filesystem_helper PRIVATE -DHAS_STD_FILESYSTEM)
+else()
+    target_link_libraries(filesystem_helper PUBLIC Boost::filesystem)
+endif()
+
 add_executable(libime_migrate_fcitx4_table libime_migrate_fcitx4_table.cpp)
-target_link_libraries(libime_migrate_fcitx4_table LibIME::Table Boost::iostreams Boost::filesystem)
+target_link_libraries(libime_migrate_fcitx4_table LibIME::Table Boost::iostreams filesystem_helper)
 install(TARGETS libime_migrate_fcitx4_table DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT tools)
 add_executable(LibIME::migrate_fcitx4_table ALIAS libime_migrate_fcitx4_table)
 
 add_executable(libime_migrate_fcitx4_pinyin libime_migrate_fcitx4_pinyin.cpp)
-target_link_libraries(libime_migrate_fcitx4_pinyin LibIME::Pinyin Boost::iostreams Boost::filesystem)
+target_link_libraries(libime_migrate_fcitx4_pinyin LibIME::Pinyin Boost::iostreams filesystem_helper)
 install(TARGETS libime_migrate_fcitx4_pinyin DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT tools)
 add_executable(LibIME::migrate_fcitx4_pinyin ALIAS libime_migrate_fcitx4_pinyin)

=== src/libime/pinyin/CMakeLists.txt ===
--- 
+++ 
@@ -32,7 +32,7 @@
                   PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/LibIMEPinyinConfigVersion.cmake")
 set(IMEPinyin_SOVERSION 0)
 
-add_library(IMEPinyin SHARED ${LIBIME_PINYIN_SRCS})
+add_library(IMEPinyin ${LIBIME_PINYIN_SRCS})
 set_target_properties(IMEPinyin PROPERTIES
                       VERSION ${IMEPinyin_VERSION}
                       SOVERSION ${IMEPinyin_SOVERSION}

=== debian/changelog ===
libime (1.1.10+dict20250327-1build2) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:12:09 +0200

libime (1.1.10+dict20250327-1build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:01:45 +0200

## libime 1.1.11

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.12)
-project(libime VERSION 1.1.10)
+project(libime VERSION 1.1.11)
 set(LibIME_VERSION ${PROJECT_VERSION})
 
 find_package(ECM 1.0 REQUIRED)
@@ -34,20 +34,14 @@
 pkg_check_modules(ZSTD REQUIRED IMPORTED_TARGET "libzstd")
 
 find_package(Fcitx5Utils REQUIRED)
+
+set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
+set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
+set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
+
 include("${FCITX_INSTALL_CMAKECONFIG_DIR}/Fcitx5Utils/Fcitx5CompilerSettings.cmake")
 
-include(CheckCXXSourceCompiles)
-check_cxx_source_compiles("
-#include <filesystem>
-int main() {
-    return std::filesystem::absolute(\".\").string()[0] == '/';
-}
-" HAS_STD_FILESYSTEM)
-
-find_package(Boost 1.61 REQUIRED COMPONENTS iostreams)
-if (NOT HAS_STD_FILESYSTEM)
-    find_package(Boost REQUIRED COMPONENTS filesystem)
-endif()
+find_package(Boost 1.61 CONFIG REQUIRED COMPONENTS iostreams)
 
 set(LIBIME_INSTALL_PKGDATADIR "${CMAKE_INSTALL_FULL_DATADIR}/libime")
 set(LIBIME_INSTALL_LIBDATADIR "${CMAKE_INSTALL_FULL_LIBDIR}/libime")

=== src/libime/CMakeLists.txt ===
add_subdirectory(core)
add_subdirectory(pinyin)
add_subdirectory(table)

=== src/libime/core/CMakeLists.txt ===
--- 
+++ 
@@ -77,7 +77,7 @@
 )
 target_include_directories(IMECore PUBLIC
     $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../..>
-    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
+    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/../..>
     $<INSTALL_INTERFACE:${CMAKE_INSTALL_FULL_INCLUDEDIR}/LibIME>)
 
 target_link_libraries(IMECore PUBLIC Fcitx5::Utils Boost::boost PRIVATE kenlm Boost::iostreams PkgConfig::ZSTD)

=== src/libime/core/kenlm/util/CMakeLists.txt ===
# Explicitly list the source files for this subdirectory
#
# If you add any source files to this subdirectory
#    that should be included in the kenlm library,
#        (this excludes any unit test files)
#    you should add them to the following list:
#
# Because we do not set PARENT_SCOPE in the following definition,
#    CMake files in the parent directory won't be able to access this variable.
#
set(KENLM_UTIL_SOURCE
		bit_packing.cc
		ersatz_progress.cc
		exception.cc
		file.cc
		file_piece.cc
		float_to_string.cc
		integer_to_string.cc
		mmap.cc
		murmur_hash.cc
		parallel_read.cc
		pool.cc
		read_compressed.cc
		scoped.cc
    spaces.cc
		string_piece.cc
		usage.cc
	)

if (WIN32)
  set(KENLM_UTIL_SOURCE ${KENLM_UTIL_SOURCE} getopt.c)
endif()

# This directory has children that need to be processed
add_subdirectory(double-conversion)
add_subdirectory(stream)

add_library(kenlm_util ${KENLM_UTIL_DOUBLECONVERSION_SOURCE} ${KENLM_UTIL_STREAM_SOURCE} ${KENLM_UTIL_SOURCE})
# Since headers are relative to `include/kenlm` at install time, not just `include`
target_include_directories(kenlm_util PUBLIC $<INSTALL_INTERFACE:include/kenlm>)

set(READ_COMPRESSED_FLAGS)
find_package(ZLIB)
if (ZLIB_FOUND)
  set(READ_COMPRESSED_FLAGS "${READ_COMPRESSED_FLAGS} -DHAVE_ZLIB")
  target_link_libraries(kenlm_util PRIVATE ${ZLIB_LIBRARIES})
  include_directories(${ZLIB_INCLUDE_DIR})
endif()

find_package(BZip2)
if (BZIP2_FOUND)
  set(READ_COMPRESSED_FLAGS "${READ_COMPRESSED_FLAGS} -DHAVE_BZLIB")
    target_link_libraries(kenlm_util PRIVATE ${BZIP2_LIBRARIES})
  include_directories(${BZIP2_INCLUDE_DIR})
endif()

find_package(LibLZMA)
if (LIBLZMA_FOUND)
  set(READ_COMPRESSED_FLAGS "${READ_COMPRESSED_FLAGS} -DHAVE_XZLIB")
      target_link_libraries(kenlm_util PRIVATE ${LIBLZMA_LIBRARIES})
  include_directories(${LIBLZMA_INCLUDE_DIRS})
endif()
if (NOT "${READ_COMPRESSED_FLAGS}" STREQUAL "")
  set_source_files_properties(read_compressed.cc PROPERTIES COMPILE_FLAGS ${READ_COMPRESSED_FLAGS})
  set_source_files_properties(read_compressed_test.cc PROPERTIES COMPILE_FLAGS ${READ_COMPRESSED_FLAGS})
  set_source_files_properties(file_piece_test.cc PROPERTIES COMPILE_FLAGS ${READ_COMPRESSED_FLAGS})
endif()

if(UNIX)
  include(CheckLibraryExists)
  check_library_exists(rt clock_gettime "clock_gettime from librt" HAVE_CLOCKGETTIME_RT)
  if (HAVE_CLOCKGETTIME_RT)
    set(RT rt)
  else()
    check_library_exists(c clock_gettime "clock_gettime from the libc" HAVE_CLOCKGETTIME)
  endif()

  if (HAVE_CLOCKGETTIME_RT OR HAVE_CLOCKGETTIME)
    add_definitions(-DHAVE_CLOCKGETTIME)
  endif()
endif()

# Group these objects together for later use.
set_target_properties(kenlm_util PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_link_libraries(kenlm_util
  PUBLIC
  # Boost is required for building binaries and tests
  "$<BUILD_INTERFACE:${Boost_LIBRARIES}>"
  PRIVATE
  Threads::Threads
  ${RT})

install(
  TARGETS kenlm_util
  EXPORT kenlmTargets
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
  INCLUDES DESTINATION include
)

if (NOT WIN32)
AddExes(EXES probing_hash_table_benchmark
        LIBRARIES kenlm_util Threads::Threads)
endif()

# Only compile and run unit tests if tests should be run
if(BUILD_TESTING)
  set(KENLM_BOOST_TESTS_LIST
    bit_packing_test
    integer_to_string_test
    joint_sort_test
    multi_intersection_test
    pcqueue_test
    probing_hash_table_test
    read_compressed_test
    sized_iterator_test
    sorted_uniform_test
    string_stream_test
    tokenize_piece_test
  )

  AddTests(TESTS ${KENLM_BOOST_TESTS_LIST}
           LIBRARIES kenlm_util Threads::Threads)

  # file_piece_test requires an extra command line parameter
  KenLMAddTest(TEST file_piece_test
               LIBRARIES kenlm_util Threads::Threads
               TEST_ARGS ${CMAKE_CURRENT_SOURCE_DIR}/file_piece.cc)
endif()

=== debian/changelog ===
libime (1.1.11-1) unstable; urgency=medium

  * New upstream release.
  * debian/control: No longer build-depends on libboost-filesystem-dev.
  * debian/copyright: Minor updates.

 -- Boyuan Yang <byang@debian.org>  Tue, 12 Aug 2025 10:34:08 -0400

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,6 @@
  debhelper-compat (= 13),
  extra-cmake-modules,
  libboost-dev (>= 1.61),
- libboost-filesystem-dev (>= 1.61),
  libboost-iostreams-dev (>= 1.61),
  libdouble-conversion-dev (>= 3.1.5-5~),
  libfcitx5utils-dev (>= 5.1~),
